﻿namespace SOLID_DIP
{
    // Aqui classe Notificacao tem uma dependência da classe Email. 
    // Neste caso, a notificação cria uma instância do e-mail 
    // diretamente dentro do construtor e sabe exatamente que 
    // tipo de classe de e-mail está criando e consumindo. 
    // Isso viola a DIP.

    /// <summary>
    //  note que o módulo que contém o logica de alto nível, ou seja, 
    //  o módulo Notificacao(), é dependente dos módulos detalhados de 
    //  baixo nível que ele controla. (isto é Email)
    //
    // Se pudéssemos encontrar uma maneira de fazer o módulo Notificao()
    // ser independente dos detalhes que ele controla, então poderíamos 
    // reutilizá-lo livremente.
    // TEMOS QUE FAZER A INVERSÃO DA DEPENDENCIA 
    /// </summary>
    public class Notificacao
    {
        private Email _email;
        public Notificacao()
        {
            _email = new Email();
        }

        public void EnviarNotificacaoSuporte()
        {
            _email.EnviaEmail();
        }
    }
}
